Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
RandomNumberGenerator Class Reference

Interface for random number generators. More...

Inheritance diagram for RandomNumberGenerator:

## Public Member Functions
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual byte | GenerateByte ()
| Generate new random byte and return it. More...
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive. More...
virtual void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
virtual void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Detailed Description

Interface for random number generators.

The library provides a number of random number generators, from software based to hardware based generators.

All generated values are uniformly distributed over the range specified.

Since
  Crypto++ 3.1

See also
  RandomNumberGenerator on the Crypto++ wiki

Definition at line 1439 of file cryptlib.h.

## Member Function Documentation

## ◆ IncorporateEntropy()

virtual void RandomNumberGenerator::IncorporateEntropy | ( | const byte * | input,
|  | size_t | length
| ) |  |
| inline virtual

Update RNG state with additional unpredictable values.

Parameters

  input | the entropy to add to the generator
  length | the size of the input buffer

Exceptions

  NotImplemented |

A generator may or may not accept additional entropy. Call CanIncorporateEntropy() to test for the ability to use additional entropy.

If a derived class does not override IncorporateEntropy(), then the base class throws NotImplemented.

Reimplemented in NIST_DRBG, RDSEED, RDRAND, OldRandomPool, RandomPool, PadlockRNG, AutoSeededX917RNG< BLOCK_CIPHER >, MersenneTwister< K, M, N, F, S >, MersenneTwister< 0x9908B0DF, 397, 624, 0x6C078965, 5489 >, MersenneTwister< 0x9908B0DF, 397, 624, 0x10DCD, 4537 >, HMAC_DRBG< HASH, STRENGTH, SEEDLENGTH >, Hash_DRBG< HASH, STRENGTH, SEEDLENGTH >, and DARN.

Definition at line 1452 of file cryptlib.h.

## ◆ CanIncorporateEntropy()

virtual bool RandomNumberGenerator::CanIncorporateEntropy | ( |  | ) | const
| inline virtual

Determines if a generator can accept additional entropy.

Returns
  true if IncorporateEntropy() is implemented

Reimplemented in OldRandomPool, RandomPool, AutoSeededX917RNG< BLOCK_CIPHER >, MersenneTwister< K, M, N, F, S >, MersenneTwister< 0x9908B0DF, 397, 624, 0x6C078965, 5489 >, MersenneTwister< 0x9908B0DF, 397, 624, 0x10DCD, 4537 >, and NIST_DRBG.

Definition at line 1460 of file cryptlib.h.

## ◆ GenerateByte()

virtual byte RandomNumberGenerator::GenerateByte | ( |  | ) |
| virtual

Generate new random byte and return it.

Returns
  a random 8-bit byte

Default implementation calls GenerateBlock() with one byte.

All generated values are uniformly distributed over the range specified within the the constraints of a particular generator.

Reimplemented in OldRandomPool, and PublicBlumBlumShub.

## ◆ GenerateBit()

virtual unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) |
| virtual

Generate new random bit and return it.

Returns
  a random bit

The default implementation calls GenerateByte() and return its lowest bit.

All generated values are uniformly distributed over the range specified within the the constraints of a particular generator.

Reimplemented in PublicBlumBlumShub.

## ◆ GenerateWord32()

virtual word32 RandomNumberGenerator::GenerateWord32 | ( | word32 | min = `0`,
|  | word32 | max = `0xffffffffUL`
| ) |  |
| virtual

Generate a random 32 bit word in the range min to max, inclusive.

Parameters

  min | the lower bound of the range
  max | the upper bound of the range

Returns
  a random 32-bit word

The default implementation calls Crop() on the difference between max and min, and then returns the result added to min.

All generated values are uniformly distributed over the range specified within the the constraints of a particular generator.

Reimplemented in OldRandomPool, MersenneTwister< K, M, N, F, S >, MersenneTwister< 0x9908B0DF, 397, 624, 0x6C078965, 5489 >, and MersenneTwister< 0x9908B0DF, 397, 624, 0x10DCD, 4537 >.

## ◆ GenerateBlock()

virtual void RandomNumberGenerator::GenerateBlock | ( | byte * | output,
|  | size_t | size
| ) |  |
| virtual

Generate random array of bytes.

Parameters

  output | the byte buffer
  size | the length of the buffer, in bytes

All generated values are uniformly distributed over the range specified within the the constraints of a particular generator.

Note
  A derived generator must override either GenerateBlock() or GenerateIntoBufferedTransformation(). They can override both, or have one call the other.

Reimplemented in NIST_DRBG, AdditiveCipherTemplate< BASE >, LC_RNG, RDSEED, RDRAND, OldRandomPool, PadlockRNG, BlockingRng, NonblockingRng, MersenneTwister< K, M, N, F, S >, MersenneTwister< 0x9908B0DF, 397, 624, 0x6C078965, 5489 >, MersenneTwister< 0x9908B0DF, 397, 624, 0x10DCD, 4537 >, HMAC_DRBG< HASH, STRENGTH, SEEDLENGTH >, Hash_DRBG< HASH, STRENGTH, SEEDLENGTH >, DARN, PublicBlumBlumShub, and Weak::ARC4_Base.

## ◆ GenerateIntoBufferedTransformation()

virtual void RandomNumberGenerator::GenerateIntoBufferedTransformation | ( | BufferedTransformation & | target,
|  | const std::string & | channel,
|  | lword | length
| ) |  |
| virtual

Generate random bytes into a BufferedTransformation.

Parameters

  target | the BufferedTransformation object which receives the bytes
  channel | the channel on which the bytes should be pumped
  length | the number of bytes to generate

The default implementation calls GenerateBlock() and pumps the result into the DEFAULT_CHANNEL of the target.

All generated values are uniformly distributed over the range specified within the the constraints of a particular generator.

Note
  A derived generator must override either GenerateBlock() or GenerateIntoBufferedTransformation(). They can override both, or have one call the other.

Reimplemented in X917RNG, OldRandomPool, RandomPool, and AutoSeededX917RNG< BLOCK_CIPHER >.

## ◆ DiscardBytes()

virtual void RandomNumberGenerator::DiscardBytes | ( | size_t | n | ) |
| virtual

Generate and discard n bytes.

Parameters

  n | the number of bytes to generate and discard

Reimplemented in RDSEED, RDRAND, PadlockRNG, MersenneTwister< K, M, N, F, S >, MersenneTwister< 0x9908B0DF, 397, 624, 0x6C078965, 5489 >, MersenneTwister< 0x9908B0DF, 397, 624, 0x10DCD, 4537 >, DARN, and Weak::ARC4_Base.

## ◆ Shuffle()

template<class IT >

void RandomNumberGenerator::Shuffle | ( | IT | begin,
|  | IT | end
| ) |  |
| inline

Randomly shuffle the specified array.

Parameters

  begin | an iterator to the first element in the array
  end | an iterator beyond the last element in the array

The resulting permutation is uniformly distributed.

Definition at line 1515 of file cryptlib.h.

The documentation for this class was generated from the following file:

- cryptlib.h